C
      SUBROUTINE MOPEG(V, X, DX, DOGRAD, N3TMP)
C
C   This subprogram computes the energy and gradient in
C   atomic units given the geometry, also in atomic units.
C
         IMPLICIT DOUBLE PRECISION (A-H,O-Z)
         LOGICAL DOGRAD
C
         INCLUDE 'SIZES.i'
         INCLUDE 'param.inc'
         INCLUDE 'percon.inc'
C
C   MOPAC common blocks
C
         COMMON /GEOKST/ MATOMS,LABELS(NUMATM),
     1                   NA(NUMATM),NB(NUMATM),NC(NUMATM)
         COMMON /GEOVAR/ XDUMMY(MAXPAR), NVAR, LOC(2,MAXPAR)            
         COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                   LOCDEP(MAXPAR)
         COMMON /MOLKSI/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),
     1                   NMIDLE(NUMATM),NLAST(NUMATM), NORBS,
     2                   NELECS,NALPHA,NBETA,NCLOSE,NOPEN
         COMMON /MOLKSR/ FRACT
         COMMON /COORD/ COORD(3,NUMATM)
C
C   POLYRATE common block
C
         COMMON /IMINCM/ NDIM(8),IND(N3TM),INDX(N3TM,8)                    0730PF97
C
         DIMENSION X(N3TMP), DX(N3TMP)
         DIMENSION DXYZ(MAXPAR)
C
C   MOPAC data statements
C
         SAVE
         DATA ANGSAU  /1.8897265D0/
         DATA CALAU   /627.503D0/
C
C   Turn off the symmetry restrictions if they are on; this ensures
C   that the derivative of the energy with respect to all the
C   coordinates are returned.
C
         IF (NDEP .NE. 0) NDEP = 0
C
C   The variable NUMAT is not going to be updated until a MOPAC calculation
C   took place.  Therefore, an optimization is required,
C
         LINDX = 1
         DO 10 I = 1,NUMAT
               COORD(1,I) = X(IND(LINDX))/ANGSAU
               COORD(2,I) = X(IND(LINDX+1))/ANGSAU
               COORD(3,I) = X(IND(LINDX+2))/ANGSAU
               LINDX = LINDX + 3
 10      CONTINUE
C
C   Set up constants and flags
C
         NA(1)=99
C
C   Calculate NUMAT and remove the dummy atoms, if any, from the
C   array that contains the atom labels.
C
         NUMAT=0
         DO 15 I=1,MATOMS
               IF(LABELS(I).NE.99.AND.LABELS(I).NE.107) THEN
                  NUMAT=NUMAT+1
                  LABELS(NUMAT)=LABELS(I)
               ENDIF
 15      CONTINUE
         MATOMS=NUMAT
C
C   Set up the variables in the array LOC; LOC(1,I)=atom to be optimized,
C   LOC(2,I)=internal coordinate to be optimized.
C
         NVAR=0
         DO 20 I=1,NUMAT
         DO 20 J=1,3
               NVAR=NVAR+1
               LOC(1,NVAR)=I
               LOC(2,NVAR)=J
 20      CONTINUE
C
         CALL COMPFG(COORD, .TRUE., ESCF, .TRUE.,DXYZ , DOGRAD)
C
         V = ESCF/CALAU
C
         IF (DOGRAD) THEN                                               1231WH94
            N3 = 3*NUMAT
            DO 30 I = 1,N3
               DX(IND(I)) = DXYZ(I)/ANGSAU/CALAU                        1229WH94
 30         CONTINUE
         ENDIF
C
         RETURN
         END
c
      SUBROUTINE MOPOPT(IOP)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      INCLUDE 'SIZES.i'
      include 'param.inc'
C
      PARAMETER (N3TM = 3*NATOMS)
C
C   MOPAC common blocks
C
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOVAR/ XPARAM(MAXPAR), NVAR, LOC(2,MAXPAR)               
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOKST/ MAXATM,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /MOLKSI/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),
     1                NMIDLE(NUMATM),NLAST(NUMATM), NORBS,
     2                NELECS,NALPHA,NBETA,NCLOSE,NOPEN
      COMMON /MOLKSR/ FRACT
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /NUMCAL/ NUMCAL
      COMMON /TIMER / TIME0
      COMMON /PATHI / LATOM,LPARAM
      COMMON /PATHR / REACT(200)
      COMMON /COORD/ COORD(3,NUMATM)
C
      COMMON /SRPI/ IBTPTR(107), NATPTR(MXATSP), NATSP
     *       /SRPL/ ISSRP
     *       /SRPR/ BETSS(MAXBET), BETSP(MXATSP,MXATSP), BETPP(MAXBET)
      LOGICAL ISSRP
C
C  POLYRATE common blocks
C
      COMMON /PEFCOM/ V,X(N3TM),DV(N3TM)
      COMMON /IMINCM/ NDIM(8),IND(N3TM),INDX(N3TM,8)                    0730PF97
C
C   The following statements are for MORATE.  This common block is used
C   to pass the unit number for the MOPAC input data file in MORATE.
C   MOPAC subprograms in MORATE read input data off of unit IREAD and
C   not unit 5, which is the unit number used in MOPAC.
C   GEODUM is a dummy array which has been introduced because the
C   subprogram GMETRY, which computes the Cartesian coordinates from
C   the bond lengths and angles, changes the bond lengths and angles
C   during the conversion.
C
      COMMON /IOCM/ IREAD
      DIMENSION GEODUM(3, NUMATM)
      EQUIVALENCE (GEO, GEODUM)
C
      CHARACTER*80 KEYWRD
      SAVE
      DATA ANGSAU /1.8897265D0/
      DATA CALAU  /627.503D0/                                           1229WH94
C
C   Initialize the time, the MOPAC variable NUMCAL, and the unit number,
C   IREAD, off of which the MOPAC input data will be read.
C
      TIME0=second()
      WRITE(6, '("***** Starting MOPOPT *****")')
      NUMCAL= NUMCAL + 1
      IREAD = 70 + IOP                                                  0611PF97
C
C   Read the MOPAC input data file, check the data for inconsistencies,
C   echo the data to FORTRAN unit 6, and exit if necessary.
C
      CALL READMO
C
C INITIALIZE CALCULATION AND WRITE CALCULATION INDEPENDENT INFO
C
      IF(INDEX(KEYWRD,'0SCF') .NE. 0) THEN
         WRITE (FU6, 6000)
         STOP 'MOPOPT 1'
      ENDIF
C
      IF(INDEX(KEYWRD,'EXTERNAL') .NE. 0) THEN
         CALL MOLDAT(0)     
         CALL EXTPAR       
      ELSE
         CALL MOLDAT(2)   
      ENDIF
C
      IF (INDEX(KEYWRD,' XYZ') .NE. 0.AND.NVAR.NE.0) THEN
C
C   SET ALL OPTIMIZATION FLAGS TO 1.  IT IS POSSIBLE TO SPECIFY " XYZ"
C   AND HAVE 3N-6 FLAGS SET AND STILL NOT HAVE EVERY ATOM MARKED FOR
C   OPTIMIZATION.  THIS CAN HAPPEN IF DUMMY ATOMS ARE PRESENT
C   TO PREVENT THIS, WE EXPLICITELY SET ALL FLAGS.
C
         NVAR=0
         DO 30 I=1,MAXATM
C
C  I DON'T THINK THE FOLLOWING LOGICAL WILL EVER BE TRUE, BUT I'M NOT
C  TAKING IT OUT IN THIS VERSION, JUST IN CASE.
C
            IF(LABELS(I).EQ.99) GOTO 30
            DO 20 J=1,3
               NVAR=NVAR+1
               LOC(1,NVAR)=I
               LOC(2,NVAR)=J
   20       XPARAM(NVAR)=GEO(J,I)
   30    CONTINUE
      ENDIF
      IF (INDEX(KEYWRD,'RESTART').EQ.0)THEN
         IF (INDEX(KEYWRD,'1SCF') .NE. 0) THEN
            IF(LATOM.NE.0)THEN
               WRITE (FU6, 6100)
               STOP 'MOPOPT 2'
            ENDIF
            NVAR=0
            IF(INDEX(KEYWRD,'GRAD').NE.0) THEN
               NVAR=0
               DO 50 I=2,MAXATM
                  IF(LABELS(I).EQ.99) GOTO 50
                  IF(I.EQ.2)ILIM=1
                  IF(I.EQ.3)ILIM=2
                  IF(I.GT.3)ILIM=3
                  DO 40 J=1,ILIM
                     NVAR=NVAR+1
                     LOC(1,NVAR)=I
                     LOC(2,NVAR)=J
   40             XPARAM(NVAR)=GEO(J,I)
   50          CONTINUE
            ENDIF
         ENDIF
      ENDIF
c
c    Optimizers
c
      IF(INDEX(KEYWRD,'NLLSQ') .NE. 0) THEN
         CALL NLLSQ(XPARAM, NVAR )
         CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,GRAD,.TRUE.)
         GO TO 60
      ENDIF
C
      IF(INDEX(KEYWRD,'SIGMA') .NE. 0) THEN
         CALL POWSQ(XPARAM, NVAR, ESCF)
         GO TO 60
      ENDIF
C
C  EF OPTIMISATION (new method of choice for TS)
C
      IF(INDEX(KEYWRD,' EF').NE.0 .OR. INDEX(KEYWRD,' TS').NE.0) THEN
        CALL EF (XPARAM,NVAR,ESCF)
        GOTO 60
      ENDIF
C
C ORDINARY GEOMETRY OPTIMISATION
C
      CALL FLEPO(XPARAM, NVAR, ESCF)
   60 CALL WRITMO(TIME0, ESCF)
      CALL GMETRY(GEO,COORD)
C
C   Set up the geometry in Cartesians
C
      CALL GMETRY (GEODUM, COORD)
C
C   Place the Cartesians into the appropriate POLYRATE array
C
      LINDX = 1
      DO 200 I = 1,NUMAT
         X(IND(LINDX))     = COORD(1,I)*ANGSAU
         X(IND(LINDX + 1)) = COORD(2,I)*ANGSAU
         X(IND(LINDX + 2)) = COORD(3,I)*ANGSAU
         LINDX = LINDX + 3
  200 CONTINUE
C
      V = ESCF / CALAU
C
C  QUICK FIX FOR TURN OFF SYMMETRY CONSTRAINTS BEFORE POLYRATE CALCULATE
C  THE FORCE CONSTANT MATRIX.
C
      NDEP = 0
c
      TIM=second()-TIME0
C
1100  FORMAT(/,2X,T5,'Total CPU time: ',F16.2,' seconds',
     1       /,2X,T5,'***** MOPOPT completed *****',/)
6000  FORMAT(/,2X,T5,'Error: MOPOPT cannot be called with 0SCF for ',
     1               'a POLYRATE calculation')
6100  FORMAT(/,2X,T5,'Error: 1SCF specified with PATH.  ',
     1               'This pair of options is not allowd.')
C
      RETURN
      END
C
      SUBROUTINE MOPHES(XII, FMATRX, N3TMP)
C
C   This subprogram computes the NDDO Hessian matrix in
C   atomic units given the geometry, also in atomic units.
C
         IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
         INCLUDE 'SIZES.i'
         INCLUDE 'param.inc'
         INCLUDE 'percon.inc'
C
C   MOPAC common blocks
C
         COMMON /GEOKST/ MATOMS,LABELS(NUMATM),
     1                   NA(NUMATM),NB(NUMATM),NC(NUMATM)
         COMMON /GEOVAR/ XDUMMY(MAXPAR), NVAR, LOC(2,MAXPAR)
         COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                   LOCDEP(MAXPAR)
         COMMON /MOLKSI/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),
     1                   NMIDLE(NUMATM),NLAST(NUMATM), NORBS,
     2                   NELECS,NALPHA,NBETA,NCLOSE,NOPEN
         COMMON /MOLKSR/ FRACT
         COMMON /COORD/ COORD(3,NUMATM)
         DIMENSION DELDIP(3,MAXPAR),D2EMOP(MAXHES)
C
C   POLYRATE common block
C
         COMMON /IMINCM/ NDIM(8),IND(N3TM),INDX(N3TM,8)                    0730PF97
C
         DIMENSION XII(N3TMP), FMATRX(N3TMP,N3TMP)
C
C   MOPAC data statements
C
         SAVE
         DATA ANGS /0.529177D0/
         DATA CALAU /627.503D0/
         DATA FACT /6.95125D-3/
C
C   Turn off the symmetry restrictions if they are on; this ensures
C   that the derivative of the energy with respect to all the
C   coordinates are returned.
C
C
         IF (NDEP .NE. 0) NDEP = 0
C
         LINDX = 1
         DO 10 I = 1,NUMAT
               COORD(1,I) = XII(IND(LINDX))*ANGS
               COORD(2,I) = XII(IND(LINDX+1))*ANGS
               COORD(3,I) = XII(IND(LINDX+2))*ANGS
               LINDX = LINDX + 3
 10      CONTINUE
         NVIB=3*NUMAT-6
         IF (NUMAT.eq.2) NVIB=1
         CALL FMAT(D2EMOP,NVIB, TSCF, TDER, DELDIP, HEAT)
         N3=3*NUMAT
         L=1
         do 20 i=1,N3
            do 20 j=1,i 
               FMATRX(i,j)=D2EMOP(L)*ANGS*ANGS/(FACT*CALAU)*2.0D0
               FMATRX(j,i)=FMATRX(i,j)
               L=L+1
 20      continue
         RETURN
         END


         SUBROUTINE mopset
C
C   This is the SETUP subprogram for MORATE.  This subprogram does not
C   carry out any calculations per se; it checks the value of the variable
C   N3TMP, the values of the variables NATOMS and NUMATM, and initializes
C   the MOPAC variable NUMCAL.
C

         IMPLICIT DOUBLE PRECISION (A-H, O-Z)
         INCLUDE 'SIZES.i'
         INCLUDE 'param.inc'
         INCLUDE 'percon.inc'
C
C   MOPAC common block
C
         COMMON /NUMCAL/ NUMCAL
         SAVE
C
         WRITE (FU6, 1000)
C
C   Check if the values of the maximum number of atoms allowed in POLYRATE and 
C   MOPAC are compatible
C
         IF (NATOMS .GT. NUMATM) THEN
             WRITE (FU6, 6100) NATOMS, NUMATM
             STOP 'MOPSET 1'
         ENDIF
C
C   Initialize the MOPAC variable NUMCAL
C
         NUMCAL = 0
C
1000     FORMAT(/,2X,T5,'Setup has been called for MOPAC 5.08mn')
6100     FORMAT(/,2X,T5,'Error: This executable file has ',
     1                  'NATOMS greater than NUMATM,',
     2          /,2X,T12,'where NUMATM = MAXHEV + MAXLIT',
     3          /,2X,T12,'NATOMS = ', I5, T30, 'NUMATM = ', I5)
C
         RETURN
         END
