C
C***********************************************************************
C  HEADR
C***********************************************************************
C
      SUBROUTINE headr
C
C     Prints out program header to FORTRAN unit FU6
C
C     CALLED BY:
C                MAIN
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      include 'param.inc'
C
      WRITE (FU6,1000)
      WRITE (FU6,1100)
      WRITE (FU6,1200)
      WRITE (FU6,1300)
      WRITE (FU6,1400)
      WRITE (FU6,2300)
      WRITE (FU6,2400)
      WRITE (FU6,1000)
C
      RETURN
C
 1000 FORMAT(/,80('*'))
 1100 FORMAT(/,T5,'MORATE 8.5 (December 2000)')
 1200 FORMAT(/,T5,'Molecular Orbital Rate Calculations')
 1300 FORMAT(/,T5,'Yao-Yuan Chuang, Patton L. Fast, Wei-Ping Hu,',
     *  /,T5,'Gillian C. Lynch, Yi-Ping Liu, and Donald G. Truhlar')
 1400 FORMAT(T5,'Department of Chemistry and Supercomputer ',
     *               'Institute',
     *       /,T5,'University of Minnesota, Minneapolis, MN ',
     *               '55455-0431')
 2300 FORMAT(/,T5,'Copyright, 2000, University of Minnesota ')
 2400 FORMAT(//,T5,'A program for analysis of reactants, products ,',
     *               'transition states, ',
     *       /,T5,'and generalized transition states and for ',
     *               'calculating variational ',
     *       /,T5,'transition state theory rate constants and ',
     *               'multidimensional ',
     *       /,T5,'semiclassical tunneling probabilities using ',
     *               'semiempirical molecular ',
     *       /,T5,'orbital theory.')
C
      END
C
C***********************************************************************
C SETUP
C***********************************************************************
C
      SUBROUTINE setup(N3TM)
C
C     This is a dummy setup routine.
C
      RETURN
C
      END
C
C
C***********************************************************************
C SURF
C***********************************************************************
C
      SUBROUTINE surf(V,X,DX,N3TM)
C
C     This is a dummy surf routine.
C
      DIMENSION X(N3TM),DX(N3TM)
C
      RETURN
C
      END
C 
C***********************************************************************
C RPH40
C***********************************************************************
C
      SUBROUTINE rph40(IOP)
C
C     This is a dummy routine.
C
      RETURN
C
      END
c***********************************************************************
c     givtst
c***********************************************************************
      SUBROUTINE givtst(nfcvt,isct,izct,
     > lorder,smaxg,sming,slm,slp,del,nede,ele,
     > nratom,iatsv,xr,icod,nq12,nq22,ntemp,tem,natom,
     > redm,sigmaf,sigmar,amasd)
C
C    This is a dummy routine
C
      RETURN
C
      END
c ************************************************************************
c     acalc
c ************************************************************************
c
      subroutine acalc(ntyp,fmat)
c
c     Subroutine to interface with the ACES II package.  This version
c     is just a dummy routine.  To interface with ACES II you need
c     the ACESRATE package.
c
      write(6,*) 'Error - Routine acalc called'
      write(6,*) '   POLYRATE does not support the ACES interface'
      write(6,*) '   ACESRATE is necessary'
c
      stop
      end
c ***************************************************************************
c     aceset
c ***************************************************************************
c
      subroutine aceset(jtype)
c
c     This subroutine is called by prepj.  It prepares species dependent
c     data needed by the the ACES II package.  This version is a dummy
c     routine included in the POLYRATE distribution.  To use the ACES II
c     POLYRATE interface one needs the package ACESRATE.
c
c
      write(6,*)'ERROR - aceset called.  ACESRATE needed to use'
      write(6,*)'        the POLYRATE/ACES II interface'
c
      stop
      end
c ***************************************************************************
c     rbasis
c ***************************************************************************
c
c
      subroutine rbasis
c
      write(6,*)'BASIS keyword is not valid with this version of'
      write(6,*)'POLYRATE'
      stop
      end
c ***************************************************************************
c     gseta
c ***************************************************************************
c
c
      subroutine gseta
c
c     Subroutine to interface with the ACES II package.  This version
c     is just a dummy routine.  To interface with ACES II you need
c     the ACESRATE package.
c
      write(6,*) 'Error - Routine gseta called'
      write(6,*) '        POLYRATE does not support the ACES interface'
      write(6,*) '        ACESRATE is necessary'
c
      stop
      end

